set linesize 32000
set pagesize 1000
set echo on
set termout on
set trimspool on

spool localindexperformance.log

drop table range_sales;

CREATE TABLE range_sales
    (time_id        DATE,
     amount_sold    NUMBER(10,2)
    ) 
PARTITION BY RANGE (time_id)
  (
    PARTITION SALES_1900 VALUES LESS THAN (TO_DATE('01-JAN-1901','DD-MON-YYYY')),
    PARTITION SALES_1901 VALUES LESS THAN (TO_DATE('01-JAN-1902','DD-MON-YYYY')),
    PARTITION SALES_1902 VALUES LESS THAN (TO_DATE('01-JAN-1903','DD-MON-YYYY')),
    PARTITION SALES_1903 VALUES LESS THAN (TO_DATE('01-JAN-1904','DD-MON-YYYY')),
    PARTITION SALES_1904 VALUES LESS THAN (TO_DATE('01-JAN-1905','DD-MON-YYYY')),
    PARTITION SALES_1905 VALUES LESS THAN (TO_DATE('01-JAN-1906','DD-MON-YYYY')),
    PARTITION SALES_1906 VALUES LESS THAN (TO_DATE('01-JAN-1907','DD-MON-YYYY')),
    PARTITION SALES_1907 VALUES LESS THAN (TO_DATE('01-JAN-1908','DD-MON-YYYY')),
    PARTITION SALES_1908 VALUES LESS THAN (TO_DATE('01-JAN-1909','DD-MON-YYYY')),
    PARTITION SALES_1909 VALUES LESS THAN (TO_DATE('01-JAN-1910','DD-MON-YYYY'))
  )
;

insert into range_sales values (TO_DATE('01-APR-1904','DD-MON-YYYY'),1);
commit;

insert into range_sales select TO_DATE('31-DEC-1900','DD-MON-YYYY'),2 from dba_objects;
insert into range_sales select TO_DATE('31-DEC-1901','DD-MON-YYYY'),2 from dba_objects;
insert into range_sales select TO_DATE('31-DEC-1902','DD-MON-YYYY'),2 from dba_objects;
insert into range_sales select TO_DATE('31-DEC-1903','DD-MON-YYYY'),2 from dba_objects;
insert into range_sales select TO_DATE('31-DEC-1904','DD-MON-YYYY'),2 from dba_objects;
insert into range_sales select TO_DATE('31-DEC-1905','DD-MON-YYYY'),2 from dba_objects;
insert into range_sales select TO_DATE('31-DEC-1906','DD-MON-YYYY'),2 from dba_objects;
insert into range_sales select TO_DATE('31-DEC-1907','DD-MON-YYYY'),2 from dba_objects;
insert into range_sales select TO_DATE('31-DEC-1908','DD-MON-YYYY'),2 from dba_objects;
insert into range_sales select TO_DATE('31-DEC-1909','DD-MON-YYYY'),2 from dba_objects;

commit;

execute dbms_stats.gather_table_stats(NULL,'RANGE_SALES');

create index global_index on range_sales(amount_sold);

alter session set max_dump_file_size = unlimited;
ALTER SESSION SET tracefile_identifier = 'bobbydurrett';
ALTER SESSION SET EVENTS '10046 trace name context forever, level 8';

select /*+index(range_sales global_index) */ * from range_sales where amount_sold=1;

ALTER SESSION SET EVENTS '10046 trace name context OFF';

drop index global_index;

create index local_index on range_sales(amount_sold) local;

ALTER SESSION SET EVENTS '10046 trace name context forever, level 8';

select /*+index(range_sales local_index) */ * from range_sales where amount_sold=1;

ALTER SESSION SET EVENTS '10046 trace name context OFF';

drop table range_sales;

spool off
